$Console
$ScreenHide
_Source _Console
_Dest _Console

Dim PALET(255) As Integer
Dim USEDCOL(255) As Integer
Dim TPAL(15) As Integer
Dim B As String * 1
Dim PX, COLORSUSED As Integer
Dim Bytes As Long
Dim X As Integer


Cls: Print
Input "ENTER IMAGE NAME TO SCAN (IMG.BIN) :"; IMGFILENAME$
If IMGFILENAME$ = "" Then IMGFILENAME$ = "IMG.BIN"
Print IMGFILENAME$: Print
Input "ENTER PALETTE FILE NAME (VPAL.BIN) :"; PALFILENAME$
If PALFILENAME$ = "" Then PALFILENAME$ = "VPAL.BIN"
Print PALFILENAME$: Print
Open PALFILENAME$ For Binary As #1

Get #1, , PALET()
Close #1

For I = 0 To 255
    USEDCOL(I) = 0
Next I

Restore VPAL
Rem For I = 0 To 15
Rem Read X
Rem TPAL(I) = X
Rem Next I

For I = 0 To 255
    X$ = Hex$(PALET(I))
    GROW:
    If Len(X$) < 4 Then X$ = "0" + X$
    If Len(X$) < 4 Then GoTo GROW
    Print X$; ",",
Next I

Open IMGFILENAME$ For Binary As #2

Do
    Get #2, , B
    PX = Asc(B)
    Bytes = Bytes + 1
    If USEDCOL(PX) = 0 Then
        Print
        Print "FOUND COLOR INDEX: $"; Hex$(PX)
        Print "       AT BYTEPOS: "; Bytes
        USEDCOL(PX) = 1
        COLORSUSED = COLORSUSED + 1
    End If
Loop Until Bytes = 76800 Or EOF(2)
Print
Print Bytes; " PIXELS SCANNED";
Print
Print COLORSUSED; " COLORS USED IN "; IMGFILENAME$
Print
PRINT "BRIGHT COLORS INDEXS ARE USED":PRINT
For I = 0 To 255
    If USEDCOL(I) = 1 Then
        Color 10
    Else
        Color 8
    End If
    Print "$"; Hex$(I); " ";
Next I

Color 0





End




Rem DEFAULT VERA TEXT COLORS
VPAL:
Data $0000,$0FFF,$0800,$0AFE,$0C4C,$00C5,$000A,$0EE7,$0D85,$0640,$0F77,$0333,$0777,$0AF6,$008F,$0BBB








Sub CONVERTIT (INFILENAME$, OUTFILE1$, OUTFILE2$)
    Type BMPHeaderType
        id As String * 2 'Should be "BM"
        size As Long 'Size of the data
        rr1 As Integer '
        rr2 As Integer '
        offset As Long 'Position of start of pixel data
        horz As Long '
        wid As Long 'Image width
        hei As Long 'Image height
        planes As Integer '
        bpp As Integer 'Should read 8 for a 256 colour image
        pakbyte As Long '
        imagebytes As Long 'Width*Height
        xres As Long '
        yres As Long '
        colch As Long '
        ic As Long '
        pal As String * 1024 'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
    End Type
    Dim BmpHeader As BMPHeaderType
    Dim SCANLINE As String * 320

    Open INFILENAME$ For Binary As #1

    Get #1, , BmpHeader

    If BmpHeader.wid <> 320 Then
        Print "IMPROPER DIMENSIONS TO CONVERT"
        End
    End If

    ' Don't close the file just yet - we're not finished!

    Rem  Here's how to convert the 24 bit Pallette to a 12 bit one.

    Print "CONVERTING PALLETTE"
    Open OUTFILE2$ For Binary As #2

    a$ = BmpHeader.pal ' Pal is stored in a 1024 character string

    I% = 1
    For PI% = 1 To 256
        b% = Asc(Mid$(a$, I%, 1)) \ 16 'blue
        g% = Asc(Mid$(a$, I% + 1, 1)) \ 16 'green
        r% = Asc(Mid$(a$, I% + 2, 1)) \ 16 'red
        ' I% + 3 is set to zero.
        gb% = Int((g% * 16) + b%)
        gb$ = Chr$(gb%)
        r$ = Chr$(r%)
        Put #2, , gb$
        Put #2, , r$
        I% = I% + 4
    Next PI%
    Close #2
    Print OUTFILE2$; " DONE"

    Open OUTFILE1$ For Binary As #2

    Print "CONVERTING IMAGE DATA"
    For X% = 1 To BmpHeader.hei
        Get #1, , SCANLINE
        Put #2, , SCANLINE
    Next X%

    Close #2
    Close #1
    Print OUTFILE1$; " CONVERSION COMPLETE"
End Sub


